#include <algorithm>
#include <cstdlib>
#include <deque>
#include <iostream>
#include <iterator>
#include <vector>
#include <numeric>
using namespace std;

int Gen(void)
{
 return  (int)(200.0 *rand()/(RAND_MAX+1.0f));
}

int main(int argc, char* argv[]) 
{
  int size = 10;
  if(argc >= 2) size = atoi(argv[1]);
  deque<int> d;
  
  generate_n(back_inserter(d), size, Gen);
  
  copy(d.begin(),d.end(),ostream_iterator <int>(cout, ","));
 
  cout << "Converting to a vector(1)" << endl;
  vector<int> v1(d.begin(), d.end());
  cout << "Converting to a vector(2)" << endl;
  vector<int> v2;
  v2.reserve(d.size());
  v2.assign(d.begin(), d.end());
	cout <<"\nV1 "<<endl;
  copy(v1.begin(),v1.end(),ostream_iterator <int>(cout, ","));
  cout<<"\nV2 "<<endl;
  sort(v2.begin(),v2.end());
  copy(v2.begin(),v2.end(),ostream_iterator <int>(cout, ","));
	cout <<"\ncall reverse \n";
	reverse(v2.begin(),v2.end());
	copy(v2.begin(),v2.end(),ostream_iterator <int>(cout, ","));
	cout<<"\n";
	cout <<"call random_shuffle \n";
	srand(time(NULL));
	random_shuffle(v2.begin(),v2.end());
	copy(v2.begin(),v2.end(),ostream_iterator <int>(cout, ","));
	cout<<"\n";
	int a;
	a=accumulate(v2.begin(),v2.end(),0);
	cout <<"running accumulate on v2 ="<<a<<endl;
	cout <<"average ="<<(float)a/v2.size()<<endl;
}